
use simple
go

create table samptab (
  id int not null PRIMARY KEY NONCLUSTERED hash( id ) with( bucket_count = 131072), 
  name nchar(450) COLLATE Latin1_General_BIN2 not null INDEX idx2 nonclustered) 
WITH (MEMORY_OPTIMIZED=ON, DURABILITY = SCHEMA_AND_DATA);

-- durability schema_and_data is the default
create table samptab2 (
   id int not null PRIMARY KEY NONCLUSTERED hash( id ) with( bucket_count = 131072), 
   name nchar(450) COLLATE Latin1_General_BIN2 not null) 
WITH (MEMORY_OPTIMIZED=ON);

create table samptab3 (
   id int not null PRIMARY KEY NONCLUSTERED hash( id ) with( bucket_count = 131072), 
   name nchar(450) COLLATE Latin1_General_BIN2 not null) 
WITH (MEMORY_OPTIMIZED=ON, DURABILITY = SCHEMA_ONLY);

create table nohash1 (
 id int,
 name varchar(20) collate Latin1_General_100_BIN2 not null primary key nonclustered(name)
) with (memory_optimized = on, durability = schema_and_data)

-- no key needed if non-durable
create table nokey (
 id int,
 name varchar(20) collate Latin1_General_100_BIN2 not null, 
 index nameindex nonclustered(name)
) with (memory_optimized = on, durability = schema_only)

-- primary key needs an index of some kind
-- index keys need to be defined as not null
create table nokey2 (
 id int not null primary key nonclustered(id),
 name varchar(20) collate Latin1_General_100_BIN2 not null,
 --index nameindex nonclustered(name)
) with (memory_optimized = on, durability = schema_and_data)

-- be careful with composite indexes
create table composite_key (
 id int,
 name varchar(20) collate Latin1_General_100_BIN2 not null,
  constraint pk_nohash primary key nonclustered(id, name)
) with (memory_optimized = on, durability = schema_and_data)

-- table types for in-memory table variables
create type samptype as table (id int not null PRIMARY KEY NONCLUSTERED, 
                               name nchar(450) COLLATE Latin1_General_BIN2 not null INDEX idx2 nonclustered) WITH (MEMORY_OPTIMIZED=ON);

create type samptype2 as table (id int not null PRIMARY KEY NONCLUSTERED hash( id ) with( bucket_count = 131072), 
                               name nchar(450) COLLATE Latin1_General_BIN2 not null) WITH (MEMORY_OPTIMIZED=ON);

-- no primary key or unique constraint
create type samptype3 as table (id int not null INDEX idx1 NONCLUSTERED hash( id ) with( bucket_count = 131072), 
                               name nchar(450) not null) WITH (MEMORY_OPTIMIZED=ON);
go


