
use AdventureWorks2012
go

select * from sys.sql_modules
where uses_native_compilation = 1
and definition not like '%TRIGGER%'

select * from sys.sql_modules
where definition like '%PROCEDURE%'



DBCC FREEPROCCACHE 
go

-- both empty
select object_name(st.objectid), q.* from sys.dm_exec_query_stats q
cross apply sys.dm_exec_sql_text(sql_handle) st
join sys.sql_modules m
on st.objectid = m.object_id
where m.uses_native_compilation = 1

select object_name(s.object_id) as name, s.* 
from sys.dm_exec_procedure_stats s
join sys.sql_modules m
on s.object_id = m.object_id
where m.uses_native_compilation = 1
GO


-- ensure stats not on
declare @c bit
exec sp_xtp_control_proc_exec_stats @new_collection_value = 0
exec sp_xtp_control_proc_exec_stats @old_collection_value=@c output
select @c as 'collection status for proc stats'
exec [sys].[sp_xtp_control_query_exec_stats] @new_collection_value = 0
exec sp_xtp_control_query_exec_stats @old_collection_value=@c output
select @c as 'collection status for query stats'

select * from Sales.SalesOrderHeader_inmem; -- 9999 rows
select * from Sales.SalesOrderDetail_inmem; -- 49902 rows

DBCC FREEPROCCACHE 
go

-- executes in 12 seconds
EXEC Demo.usp_DemoInsertSalesOrders @use_inmem = 1, @order_count = 10000, @include_update = 1
GO

-- still nothing in here
select object_name(st.objectid), q.* from sys.dm_exec_query_stats q
cross apply sys.dm_exec_sql_text(sql_handle) st
join sys.sql_modules m
on st.objectid = m.object_id
where m.uses_native_compilation = 1

select object_name(s.object_id) as name, s.* 
from sys.dm_exec_procedure_stats s
join sys.sql_modules m
on s.object_id = m.object_id
where m.uses_native_compilation = 1
GO

-- ensure stats IS on
declare @c bit = 1;
exec [sys].[sp_xtp_control_proc_exec_stats] @new_collection_value = 1
exec sp_xtp_control_proc_exec_stats @old_collection_value= @c output
select @c as 'collection status for proc stats'
exec [sys].[sp_xtp_control_query_exec_stats] @new_collection_value = 1
exec sp_xtp_control_query_exec_stats @old_collection_value=@c output
select @c as 'collection status for query stats'

DBCC FREEPROCCACHE 
go

-- executes in 3 seconds
EXEC Demo.usp_DemoInsertSalesOrders @use_inmem = 1, @order_count = 10000, @include_update = 1
GO

select object_name(st.objectid), q.* from sys.dm_exec_query_stats q
cross apply sys.dm_exec_sql_text(sql_handle) st
join sys.sql_modules m
on st.objectid = m.object_id
where m.uses_native_compilation = 1

select object_name(s.object_id) as name, s.* 
from sys.dm_exec_procedure_stats s
join sys.sql_modules m
on s.object_id = m.object_id
where m.uses_native_compilation = 1
GO

DBCC FREEPROCCACHE 
go

-- entries related to the sprocs still there.... after DBCC FREEPROCCACHE
-- but nothing else is
select object_name(st.objectid), q.* from sys.dm_exec_query_stats q
cross apply sys.dm_exec_sql_text(sql_handle) st
join sys.sql_modules m
on st.objectid = m.object_id
where m.uses_native_compilation = 1

select object_name(s.object_id) as name, s.* 
from sys.dm_exec_procedure_stats s
join sys.sql_modules m
on s.object_id = m.object_id
where m.uses_native_compilation = 1
GO

DBCC FREEPROCCACHE
GO

-- but nothing else is left in query_stats
select object_name(st.objectid), st.text, q.* from sys.dm_exec_query_stats q
outer apply sys.dm_exec_sql_text(sql_handle) st
left join sys.sql_modules m
on st.objectid = m.object_id
--where m.uses_native_compilation = 1

select object_name(s.object_id) as name, s.* 
from sys.dm_exec_procedure_stats s
join sys.sql_modules m
on s.object_id = m.object_id
--where m.uses_native_compilation = 1
GO



select * from sys.dm_exec_cached_plans