-- we just want this one for the T-SQL original sproc

use CLRPerfDB
GO

DROP PROCEDURE tsql_ProductionScheduling_orig
go

CREATE PROCEDURE tsql_ProductionScheduling_orig
	@startDate DateTime, @numWeeks int, @pid int
AS

CREATE TABLE #Fk (k int, val int, j int)

CREATE TABLE #Fk_final (k int, val int, j int)

CREATE TABLE #CIJ ( pid int, i int, j int, C int )

CREATE TABLE #Forecast ( Product nvarchar(256), Period DateTime, Quantity int )

DECLARE @i int, @j int, @n int, @K int, @h int
--DECLARE @pid int
DECLARE @lastValue int
--These are hard coded, but need to come as paramters to storedproc
SET @n = @numWeeks
------------------------------------------------------------------
SELECT @K = StartupCost, @h = InventoryCost FROM t_Products WHERE PID = @pid
SET @i = 1
WHILE ( @i < @n+1 )
BEGIN
	SET @j = @i+1
	INSERT #CIJ VALUES (@pid,@i,@j,@K)
	SET @lastValue = @K
	SET @j = @j+1
	WHILE( @j <= @n+1 )
	BEGIN
		INSERT #CIJ SELECT PID, @i, @j, @lastValue + (@h * DemandQty * (@j-1-@i) )
			FROM t_SalesForecast
			WHERE PID=@pid AND WeekDate >= @startDate
			AND WeekDate = DATEADD(Week,@j-2,@startDate)

		SELECT @lastValue = C FROM #CIJ
			WHERE i=@i AND j=@j
	SET @j = @j+1
	END
SET @i = @i+1
END
--SELECT * FROM #CIJ
--Calculate Fk
SET @n = @numWeeks
SET @k = @n+1
INSERT #Fk VALUES( @k, 0, @k+1)
SET @k = @k-1
WHILE( @k >= 1  )
BEGIN
	INSERT #Fk
	SELECT @k, MIN( t.C + f.val ), t.j
	FROM #CIJ t, #Fk f
	WHERE t.i = @k AND t.j > @k AND f.k = t.j
	GROUP BY t.j
SET @k = @k-1
END

INSERT #Fk_final
SELECT Z.k, Z.val, Y.j
FROM
	(SELECT k, MIN(val) AS val FROM #Fk GROUP BY k) Z
	JOIN #Fk Y ON Z.k=Y.k AND Z.val=Y.val
--SELECT * FROM #FK_final

DECLARE @product nvarchar(256)
SELECT @product = Pname FROM t_Products WHERE PID = @pid
--SET @startIndex = 1
DECLARE @sum int, @optimal_j int
DECLARE @week DateTime
DECLARE @period int
SET @k = 1
SET @n = @numWeeks
WHILE ( @k <= @n )
BEGIN
	SET @period = @k
	SELECT @optimal_j = j FROM #Fk_final WHERE k=@k
	SET @sum = 0
	WHILE( @k < @optimal_j )
	BEGIN
		SELECT @sum = @sum + DemandQty FROM t_SalesForecast 
			WHERE WeekDate = DATEADD(Week,@k-1,@startDate)
			AND PID = @pid
		SELECT @week = WeekDate FROM t_SalesForecast
			WHERE WeekDate = DATEADD(Week,@period-1,@startDate)
			AND PID = @pid
	SET @k = @k+1
	END
	INSERT #Forecast SELECT @product, @week, @sum
END

SELECT * FROM #Forecast
go
